; others.lsp

;(defun remove-one (data obj)
;    (let ((ans nil))
;	(loop
;	    (if (null obj) (return ans))
;	    (if (equal data (car obj)) (return (append ans (cdr obj))))
;	    (if (and (stringp data) (stringp (car obj)) (string-equal data (car obj))) (return (append ans (cdr obj))))
;	    (setq ans (append ans (list (car obj))))
;	    (setq obj (cdr obj)) ) ) )

;(defun sort-one (obj test)
;    (let ((koho (car obj))
;	  (rest (cdr obj)))
;	(loop
;	    (if (null rest) (return koho))
;	    (if (funcall test (car rest) koho) (setq koho (car rest)))
;	    (setq rest (cdr rest)) ) ) )

; ֐SORT objtesťŃ\[g܂B
;(defun sort (obj test)
;    (let ((ans nil) (one))
;	(loop
;	    (if (null (cdr obj)) (return (append ans obj)))
;	    (setq one (sort-one obj test))
;	    (setq ans (append ans (list one)))
;	    (setq obj (remove-one one obj)) ) ) )


;--------------------------------------------------

; ֐STRING/=
(defun string/= (x y)
    (let ((x1 (coerce x 'list))
	  (y1 (coerce y 'list)) )
	(string/=sub x1 y1 0) ) )

(defun string/=sub (x1 y1 n)
    (cond
	((and (null x1) (null y1)) nil)
	((null x1) n)
	((null y1) n)
	((eql (car x1) (car y1))
	 (string/=sub (cdr x1) (cdr y1) (1+ n)) )
	(t n) ) )

; ֐STRING=
(defun string= (x y) (string-equal x y))

; ֐STRING<
(defun string< (x y)
    (let ((x1 (coerce x 'list))
	  (y1 (coerce y 'list)) )
	(string<sub x1 y1 0) ) )

(defun string<sub (x1 y1 n)
    (cond
	((and (null x1) (null y1)) nil)
	((null x1) n)
	((null y1) nil)
	((char< (car x1) (car y1)) n)
	((char= (car x1) (car y1))
	 (string<sub (cdr x1) (cdr y1) (1+ n)) )
	(t nil) ) )

; ֐STRING<=
(defun string<= (x y)
    (let ((x1 (coerce x 'list))
	  (y1 (coerce y 'list)) )
	(string<=sub x1 y1 0) ) )

(defun string<=sub (x1 y1 n)
    (cond
	((and (null x1) (null y1)) n)
	((null x1) n)
	((null y1) nil)
	((char< (car x1) (car y1)) n)
	((char= (car x1) (car y1))
	 (string<=sub (cdr x1) (cdr y1) (1+ n)) )
	(t nil) ) )

; ֐STRING>
(defun string> (x y)
    (let ((x1 (coerce x 'list))
	  (y1 (coerce y 'list)) )
	(string>sub x1 y1 0) ) )

(defun string>sub (x1 y1 n)
    (cond
	((and (null x1) (null y1)) nil)
	((null x1) nil)
	((null y1) n)
	((char> (car x1) (car y1)) n)
	((char= (car x1) (car y1))
	 (string>sub (cdr x1) (cdr y1) (1+ n)) )
	(t nil) ) )

; ֐STRING>=
(defun string>= (x y)
    (let ((x1 (coerce x 'list))
	  (y1 (coerce y 'list)) )
	(string>=sub x1 y1 0) ) )

(defun string>=sub (x1 y1 n)
    (cond
	((and (null x1) (null y1)) n)
	((null x1) nil)
	((null y1) n)
	((char> (car x1) (car y1)) n)
	((char= (car x1) (car y1))
	 (string>=sub (cdr x1) (cdr y1) (1+ n)) )
	(t nil) ) )

; }NDO*
(defmacro do* (a b &rest c)
    `(prog ,(mapcar #'car a)
	   ,@(mapcar #'(lambda (x) (list 'setq (car x) (cadr x))) a)
        label
	   (if ,(car b) (return ,(if (null (cdr b)) nil (cadr b))))
	   ,@c
	   ,@(mapcar #'(lambda (x) (list 'setq (car x) (caddr x))) a)
	   (go label)
     ) )

; ֐FLOOR
; x͐
;(defun floor (x &rest y)
;    (cond
;	((null y) (setq y 1))
;	(t (setq y (car y))) )
;    (if (< x y) (values 0 x)
;	(multiple-value-bind (q r) (floor (- x y) y)
;	    (values (+ q 1) r))))

; ֐MOD
;(defun mod (x y)
;    (let ((n (floor (/ x y))))
;	(- x (* n y)) ) )


;(defun second (x) (cadr x))

;---------------------------------------------------------------------------------------------------------
(defun concatenate (type &rest b)
    (let ()
	(cond
	    ((eql type 'string)
	     (cond
		((not (is-all-string b)) (print '(some element is not a string)) nil)
		(t (set-array (cons 1 (cons 'character (apply #'append (mapcar
			(lambda (x)
			    (copy (cdr (array-cdr x))) ) b ) ) ) ) ) ) ) )
	    ((eql type 'list)
	     (apply #'append (mapcar
		(lambda (x)
		    (cond
			((stringp x) (copy (cdr (array-cdr x))))
			(t x) ) ) b ) ) )
	    (t (print '(bad usage for concatenate)) nil) ) ) )

(defun is-all-string (lst)
    (cond
	((atom lst) t)
	((stringp (car lst)) (is-all-string (cdr lst)))
	(t nil) ) )

;-------------------------------------------------------------------------------------------------------------
(defun equalp (x y)
    (if (and (arrayp x) (arrayp y))
	(if (eql (array-car x) (array-car y))
	    (if (eql (car (array-cdr x)) (car (array-cdr y)))
		(equalp (cdr (array-cdr x)) (cdr (array-cdr y)))
		nil )
	    nil )
	(if (atom x) (eql x y)
	    (if (atom y) nil
		(if (equalp (car x) (car y))
		    (equalp (cdr x) (cdr y))
		    nil ) ) ) ) )

;-------------------------------------------------------------------------------------------------
;(defun mod (u k)
;    (cond
;        ((< u k) u)
;	(t (mod (- u k) k)) ) )

(defun ceiling (x &rest b)
    (let ((y))
	(setq y (multiple-value-list (apply 'floor (cons x b))))
	(values (+ 1 (car y)) (- (car (cdr y)) 1)) ) )

(defun abs (x)
    (cond
	((minusp x) (* -1 x))
	(t x) ) )

; end of file

